# Class FaceLandmarks

java.lang.Object
com.codename1.ai.vision.FaceLandmarks

public final class FaceLandmarks extends Object

The keys `Face.getLandmarks()` uses, as constants instead of literals. Every backend normalizes its own landmark identifiers onto these names; a landmark the backend could not locate is absent from the map rather than present with a meaningless position, so read one through `Face.getLandmark(String)` and check for `null`.

    detector.process(VisionImage.fromCameraFrame(frame)).ready(faces -> {
        for (Face face : faces) {
            VisionPoint left = face.getLandmark(FaceLandmarks.LEFT_EYE);
            VisionPoint right = face.getLandmark(FaceLandmarks.RIGHT_EYE);
            if (left != null && right != null) {
                placeGlasses(left.toPoint(preview), right.toPoint(preview));
            }
        }
    });

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `LEFT_EYE`
  Center of the subject's left eye, which appears on the right of the image.
  `static final String`
  `MOUTH_LEFT`
  Left corner of the mouth.
  `static final String`
  `MOUTH_RIGHT`
  Right corner of the mouth.
  `static final String`
  `NOSE_BASE`
  Base of the nose, between the nostrils.
  `static final String`
  `RIGHT_EYE`
  Center of the subject's right eye, which appears on the left of the image.

- ## Method Summary

  ### Methods inherited from class Object

  `clone, equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### LEFT_EYE

    public static final String LEFT_EYE
    Center of the subject's left eye, which appears on the right of the image.
    See Also:
      - Constant Field Values

  - ### RIGHT_EYE

    public static final String RIGHT_EYE
    Center of the subject's right eye, which appears on the left of the image.
    See Also:
      - Constant Field Values

  - ### NOSE_BASE

    public static final String NOSE_BASE
    Base of the nose, between the nostrils.
    See Also:
      - Constant Field Values

  - ### MOUTH_LEFT

    public static final String MOUTH_LEFT
    Left corner of the mouth.
    See Also:
      - Constant Field Values

  - ### MOUTH_RIGHT

    public static final String MOUTH_RIGHT
    Right corner of the mouth.
    See Also:
      - Constant Field Values